The OpenNET Project / Index page

[ новости /+++ | форум | wiki | теги | ]

Доступен NumPy 1.16, последний релиз с поддержкой Python 2

21.01.2019 19:28

Доступен релиз Python-библиотеки для научных вычислений NumPy 1.16, ориентированной на работу с многомерными массивами и матрицами, а также предоставляющей большую коллекцию функций с реализацией различных алгоритмов, связанных с использованием матриц. NumPy является одной из наиболее востребованных библиотек, применяемых для научных расчётов. Код проекта написан на языке Python с применением оптимизаций на языке Си и распространяется под лицензией BSD.

NumPy 1.16 объявлен как последний выпуск, в котором сохраняется поддержка Python 2.7. Новые возможности отныне будут добавляться только в ветку для Python 3, а поддержка Python 2 ограничится исправлением ошибок. Из веток Python 3 обеспечена поддержка 3.5-3.7, поддержка ветки Python 3.4 прекращена. Сопровождение NumPy 1.16 будет обеспечено до 31 декабря 2019 года, после чего возможность дальнейшей поддержки будет зависеть от активности лиц, заинтересованных в продолжении использования Python 2. Напомним, что поддержка Python 2.7 будет прекращена сообществом разработчиков языка Python в 2020 году.

В новой версии проведён рефакторинг кодовой базы, переработана организация кода и улучшена переносимость между разными платформами. Добавлена экспериментальная поддержка переопределения функций numpy производными проектами. Функция matmul переведена в разряд универсальных (ufunc) и может быть переопределена при помощи выражения "__array_ufunc__". Улучшена поддержка архитектур ARM, POWER и SPARC, а также платформ AIX и PyPy. Улучшена переносимость с ctypes. Расширена поддержка PEP 3118 (интерфейс совместного доступа к буферам).

Дополнение: В NumPy выявлена уязвимость (CVE-2019-6446), приводящая к выполнению удалённого кода при обработке специально оформленного сериализированного объекта. Уязвимость проявляется в том числе в выпуске 1.16.0 и присутствует в коде начиная с версии 1.10 (апрель 2015), в которой был добавлен вызов "np.load(allow_pickle=True)". Проблема связана с небезопасным использованием модуля "pickle".

  1. Главная ссылка к новости (https://mail.python.org/piperm...)
  2. OpenNews: Опубликован план прекращения поддержки Python 2 в NumPy
  3. OpenNews: Выпуск инженерного дистрибутива CAELinux 2018
  4. OpenNews: Опубликованы лекции "Python в научных вычислениях"
  5. OpenNews: Релиз системы для математических расчётов GNU Octave 4.2.0
  6. OpenNews: Выпуск SciPy 1.0, библиотеки для научных и инженерных расчётов
Лицензия: CC-BY
Тип: Программы
Короткая ссылка: https://opennet.ru/50000-numpy
Ключевые слова: numpy
При перепечатке указание ссылки на opennet.ru обязательно
Обсуждение (52) Ajax | 1 уровень | Линейный | +/- | Раскрыть всё | RSS
  • 1.1, Xasd (ok), 19:43, 21/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +7 +/
    юбилейная новость -- и кстати довольно важная!

    // P.S.: https://pythonclock.org/

     
  • 1.2, A.Stahl (ok), 19:51, 21/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +1 +/
    Ну ок, Питон2 и так прожил больше, чем предполагалось. Это как 32-битный х86. Нафиг не нужен, но упорно выживает за счёт особо упорных.
     
     
  • 2.3, Аноним (3), 20:17, 21/01/2019 [^] [^^] [^^^] [ответить]  
  • +1 +/
    Он выживает за счёт тех, кому важна скорость вычислений и потребление памяти, а не номера версий вычислятора.
     
     
     
    Часть нити удалена модератором

  • 4.6, Аноним (3), 20:50, 21/01/2019 [ответить]  
  • +/
    Самопочином иди занимайся. У питона 2.7 до сих пор скорость вм выше чем у 3.7. Например, тупой вход-выход в/из функции почти в 3 раза медленнее. Активная работа с байтовыми слайсами раздувает в памяти всю третью ветку. У меня, для примера, есть aws lambda. Написана давно и аккуратно. Обычный дата-саентизм уровня "загрузить десяток мегабайт с s3, покрутить массивы в numpy, посчитать производные данные, применить модельку, записать результаты в dynamo".
    Версия на 2.7, кушает ~256MiB, работает в среднем 2 минуты и всегда укладывается в 5 минут. Версия на 3.6, не смотря на все приседания и перепиливания, жрёт , не укладывается в 5 минут и выжирает почти гигабайт.
     
     
  • 5.7, Аноним (7), 21:19, 21/01/2019 [^] [^^] [^^^] [ответить]  
  • +1 +/
    Для дата-сайнтистов есть Julia. По крайней мере, с коннекторами к источникам данных и скоростью предобработки и вычисления там проблем нет.
     
     
  • 6.9, Аноним (3), 22:11, 21/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Ещё раз. Решение есть. Работает. Свою часть работы делает хорошо. Переписывание на более новые версии было затеяно после анонса окончания поддержки амазоном.
     
     
  • 7.12, Аноним (7), 22:26, 21/01/2019 [^] [^^] [^^^] [ответить]  
  • +1 +/
    Амазону тоже хочется поиметь в 3 раза больше денег на более медленном, но более современно решении
     
  • 7.15, Аноним (15), 00:12, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +2 +/
    Интересный, кстати, это вопрос. На сколько можно доверять облачному провайдеру поддержку своей логики, если в любой момент времени они могут изменить версии инструментов и сделать эту логику нерабочей.... В части Амазона, это, скорее, сигнал, чтобы не использовать их.
     
  • 7.16, Vkni (ok), 01:11, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    В культуре Питонистов есть зуд к изменениям. Поэтому если вы хотите сделать что-то надолго, то брать Питон нежелательно. Не из-за недостатков языка, а потому, что они хотят улучшать и улучшать, очень часто не оглядываясь на обратную совместимость.
     
     
  • 8.23, Аноним (23), 05:46, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Уж кто кто а питонисты сделали очень многое, чтобы сгладить переход ... текст свёрнут, показать
     
     
  • 9.47, Vkni (ok), 17:02, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    А у C ников вообще никакого перехода нет ... текст свёрнут, показать
     
     
  • 10.62, нах (?), 12:20, 23/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    здрасьте, как это так нет, когда каждый год новый стандарт У c ников ситуация ... текст свёрнут, показать
     
  • 10.65, й (?), 19:57, 23/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    ага, то-то примеры из книжки страуструпа ты современным компилятором не скомпили... текст свёрнут, показать
     
  • 8.32, PnDx (ok), 11:48, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Чтобы сделать надолго, не надо прицеплять внешний рантайм Внезапно, даже в glib... текст свёрнут, показать
     
     
  • 9.36, нах (?), 13:02, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    погоди, у нас же уже есть прекрасный perl6 Он, правда, в сферическом вакууме... текст свёрнут, показать
     
     
  • 10.40, PnDx (ok), 13:33, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +1 +/
    Эти старпёры не догадались объявить perl6 заменой perl5 А может, заложенные ... текст свёрнут, показать
     
  • 10.60, myhand (ok), 21:53, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Конкурент брайнфаку таки растет ... текст свёрнут, показать
     
  • 6.17, Vkni (ok), 01:11, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • –2 +/
    R и data.table - засасывает гигабайнтный csv за десятки секунд.
     
  • 6.27, klonov (?), 09:03, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Или все еще в уме надо отлаживать?
     
  • 5.13, Аноним (13), 23:01, 21/01/2019 [^] [^^] [^^^] [ответить]  
  • +1 +/
    давай прувы, трепло, конкретный код давай, показывай, что, где и с какой скоростью работает
     
  • 3.51, myhand (ok), 17:44, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Он выживает за счет "коммерческого" говнокода, на сопровождение которого забили.
     
  • 2.18, Vkni (ok), 01:17, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Я могу объяснить, как это так получается. В культуре Питонистов есть страсть к изменениям, это лагерь фактически противоположный C++ному. Эта страсть к изменениям в сочетании с традиционной для кровавого энтерпрайза тяги к развесистым программам и с динамической типизацией языка Питон приводят к тому, что приходится жёстко фиксировать версию интерпретатора и библиотек.

    Но тут на помощь приходит python 2.x - эта ветка считается мёртвой, поэтому библиотеки под неё питонисты модифицируют не так интенсивно. Поэтому типичный "кроваво-энтерпрайзный софт" более-менее живёт годами, иногда выживая даже при смене младших версий интерпретатора (2.6 -> 2.7).

     
     
  • 3.48, Анонимчжан (?), 17:06, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    интересно а сколько стандартов С++ поменялось за последнее время? последний стандарт так и вообще создатель ++-в сказал считать новым языком фактически))  точно бредит.
    я например и с++ и питон использую. и не вижу ничего плохого. для каждой задачи свой инструмент.
     

  • 1.8, noize (ok), 21:52, 21/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    в новости забыли указать, что также выброшена поддержка python ниже 3.5, т.е. те, кто на debian jessie идут лесом)
     
     
  • 2.11, Аноним (11), 22:24, 21/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    И кто на XPюше - тоже.
     
     
  • 3.31, HatedLLVM (?), 11:17, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Те, кто на XPюше, они без браузеров даже, не говоря уж об остальном.
     
     
  • 4.61, Аноним (11), 22:40, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Да хрен с ним с браузером. Рулить древней аппаратурой с древними дровами как?
     
  • 2.37, нах (?), 13:04, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    а у вас там что - 2.7 уже выпилен?

    ну, значит, страдальцам у которых немое кино уже кончилось, а звуковое не настало, придется страдать. Страдание очищает.

     
  • 2.43, iPony (?), 14:50, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    ну так они и так лесом давно пошли в общем-то
    https://news.softpedia.com/news/debian-gnu-linux-8-jessie-will-reach-end-of-se
     

  • 1.10, Аноним (11), 22:23, 21/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    >Проблема связана с небезопасным использованием модуля "pickle".

    Безопасное использование модуля pickle почти бесполезно.

     
  • 1.14, Hellraiser (??), 23:32, 21/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +1 +/
    > те, кто на debian jessie

    покажите мне этих героев

     
  • 1.30, Аноним (30), 11:07, 22/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    Хороший мудератор: вот в этом вся суть рашен опенсурс - ответа хрен, лучше удалить вопрос.

    Как это собирать? На стадии configure пишет, что не может создать исполняемый файл. По интернетам масса таких вопросов, все без ответа.

    С компилятором/binutils всё норм - сотни пакетов собираются нормально.

     
     
  • 2.42, Андрей (??), 14:18, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    > На стадии configure пишет, что не может создать исполняемый файл.

    Если исключить тривиальную ошибку, это чаще всего означает, что компилятору скормили флаг, который он не знает. А это чаще всего бывает тогда, когда компилятор слишком старый.

     
     
  • 3.44, нах (?), 14:53, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • –1 +/
    это чаще всего означает, что компилятора нет вообще. Поскольку альтернативно-одаренный вряд ли догадался что ему нужен gfortran.

    но в любом случае ответ на этот вопрос лежит в логе конфигурялки, в который альтернативно-одаренный питонист не умеет посмотреть.

     
     
  • 4.45, нах (?), 14:57, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • –1 +/
    кстати, зачем альтернативно-одаренные его пересобирают, когда на сайте лежат новые вилы под все возможные и некоторые  невозможные платформы, тоже загадка

     
     
  • 5.59, myhand (ok), 21:50, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Ну как зачем, разве разработчики библиотеки могут собрать бинарники лучше, чем Вася Пупкин с опеннету?  Удивляюсь я.
     
  • 4.46, Аноним (30), 15:26, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Какой ты вумный...

    gcc --version
    gcc 7.3.0

    В той же системе numpy-1.10.4 собрался успешно.

    Если что, fortran - опция.

     
     
  • 5.50, Андрей (??), 17:15, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    > gcc --version

    А что говорит gfortran --version ? В зависимостях соответствующего Debian-пакета gcc не значится, только gfortran. И так уже давно.

     
     
  • 6.52, Аноним (30), 17:54, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    gfortran --version
    GNU Fortran 7.3.0
     
  • 6.53, нах (?), 17:57, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    >> gcc --version
    > А что говорит gfortran --version ? В зависимостях соответствующего Debian-пакета gcc не
    > значится, только gfortran. И так уже давно.

    ну так может (коли ты юзер дебиана) пойдешь дашь п-ы пионерам? (в смысле - хоть тикетца им заведи?)

    Потому что по факту - хрен ты его соберешь без gcc. И без g++,кстати, тоже - причем сборочница этого, к моему смеху, не проверила - просто навернулась по дороге.

    под волшебной бубунточкой, если что, собрался.

     
     
  • 7.55, Андрей (??), 18:02, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    > ну так может (коли ты юзер дебиана) пойдешь дашь п-ы пионерам? (в смысле - хоть тикетца им заведи?)

    Не надо: gfortran зависит от gcc.

     
  • 5.57, Аноним (30), 18:04, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Если что, только что пересобрал на этой машине numpy-1.10.4 - успешно.
     
  • 5.58, нах (?), 18:05, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    > Какой ты вумный...

    да блин, нафиг мне твоя версия - в лог посмотри, он им гадит прямо туда где собирается.
    Прямо в последних строчках и будет причина.

     
  • 4.49, Андрей (??), 17:12, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    > это чаще всего означает, что компилятора нет вообще.

    Этот вариант я отнёс к:
    > > Если исключить тривиальную ошибку

     
     
  • 5.54, нах (?), 17:58, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    >> это чаще всего означает, что компилятора нет вообще.
    > Этот вариант я отнёс к:
    >> > Если исключить тривиальную ошибку

    какая ж она тривиальная, если вон, дебианы взяли и забыли зависимость включить, как нам сообщают с полей? ;-)

     
     
  • 6.56, Андрей (??), 18:02, 22/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Она была бы лишней (см. выше).
     
  • 2.67, Аноним (30), 17:21, 31/01/2019 [^] [^^] [^^^] [ответить]  
  • +/
    Для истории: сборка проходит успешно, если явно выставить переменную окружения
    SHELL=/bin/bash
     
     
  • 3.68, пох (?), 07:01, 06/02/2019 [^] [^^] [^^^] [ответить]  
  • +/
    читайте логи конфигуры, истино вам говорю - они рулез.

    у меня SHELL вот ни разу не bash, и /bin/sh тоже не баш. Собирается.

     

  • 1.63, Аноним (63), 14:19, 23/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    Во непруха, это че теперь все скрипты переписывать на python 3 до 2020г.?
     
     
  • 2.64, Аноним (64), 15:11, 23/01/2019 [^] [^^] [^^^] [ответить]  
  • –1 +/
    С питона вообще давно пора слезать. Зачем что-то на него переписывать?
     

  • 1.66, Георгий (??), 17:02, 24/01/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    Давно пора.
     
  • 1.69, Аноним (69), 16:44, 20/11/2019 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    Дайте пж майн 1.16
     

     Добавить комментарий
    Имя:
    E-Mail:
    Текст:



    Спонсоры:
    Inferno Solutions
    Hosting by Hoster.ru
    Хостинг:

    Закладки на сайте
    Проследить за страницей
    Created 1996-2020 by Maxim Chirkov
    Добавить, Поддержать, Вебмастеру